VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form History 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "History"
   ClientHeight    =   5220
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   4545
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   Picture         =   "History.frx":0000
   ScaleHeight     =   5220
   ScaleWidth      =   4545
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Error 
      Caption         =   "Error Reponse"
      Height          =   1215
      Left            =   3000
      TabIndex        =   3
      Top             =   2160
      Width           =   1455
      Begin VB.OptionButton Audio 
         Caption         =   "Status Bar with Audio"
         Height          =   495
         Left            =   120
         TabIndex        =   5
         Top             =   600
         Width           =   1215
      End
      Begin VB.OptionButton StatusBar 
         Caption         =   "Status Bar"
         Height          =   375
         Left            =   120
         TabIndex        =   4
         Top             =   240
         Width           =   1215
      End
   End
   Begin MSComctlLib.StatusBar Status 
      Align           =   2  'Align Bottom
      Height          =   360
      Left            =   0
      TabIndex        =   2
      Top             =   4860
      Width           =   4545
      _ExtentX        =   8017
      _ExtentY        =   635
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   1
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
         EndProperty
      EndProperty
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   3600
      Top             =   4320
   End
   Begin VB.CommandButton Clear 
      Caption         =   "Clear History"
      Height          =   375
      Left            =   3240
      TabIndex        =   1
      Top             =   120
      Width           =   1095
   End
   Begin VB.ListBox List1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4620
      Left            =   120
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   120
      Width           =   2775
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   4080
      Top             =   4320
      _ExtentX        =   794
      _ExtentY        =   794
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.Menu File 
      Caption         =   "File"
      Begin VB.Menu InitializeRemotes 
         Caption         =   "Initialize Remotes"
         Shortcut        =   ^I
      End
   End
   Begin VB.Menu Help 
      Caption         =   "Help"
      Begin VB.Menu Instructions 
         Caption         =   "Instructions"
      End
      Begin VB.Menu About 
         Caption         =   "About"
      End
   End
End
Attribute VB_Name = "History"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'********************************************************************
'   History.frm
'       -Form called from Setup Form when user completes the setup of
'           the comm port properly.  Is the main workhorse of this
'           program.  Displays the history of all the infrared signals
'           the IRMAN receives and through the OnComm function decided
'           what to do with the given signal that has been received.
'
'   Created by: Zac M. Leider
'   Date: May 5th, 2003
'   Project: PC Remote Control (SNC Senior Capstone '03)
'
'********************************************************************

' Public variables
Dim arr() As Byte       'Used to read from the comm port
Dim buffer As Variant   'Used to read and write to the comm port

Option Explicit


'Called when form is created
Private Sub Form_Load()
    ' To correct error in properties
    History.Picture = LoadPicture()

    Dim i, j, upper As Integer
    Dim node1 As Node
   
    Dim Fso 'FileSystemObject
    Dim TStream 'TextStream
    Dim s, tf, saved2, saved() As String

    CanClose = False 'don't allow closing of Init window
   
   'Sets voice for text to speech used for reporting errors
'###################### UNCOMMENT FOR SPEECH ########################
'    Set Voice = New SpVoice
'    Set Voice = New SpVoice
'    Voice.Volume = 85
'    Voice.Rate = -1
'####################################################################

    buffer = ""
    
    'Sets up status bar
    Status.Panels(1).Width = 320
    Status.Panels.Add
    Status.Panels(2).Width = 2000
    Status.Panels.Add
    Status.Panels(3).Width = 2600
    
    Status.Panels(1).Picture = LoadPicture(GO_BMP)
    Status.Panels(2).Text = "IRMAN is initialized!"
        
    'Sets default to not play audio for error reponses
    StatusBar.Value = True
   
    'Creates a File System Object for dealing with text files
    Set Fso = CreateObject("Scripting.FileSystemObject")
    i = 1
    rcount = 0
    
    'Searches for Remote1.txt - Remote5.txt, if they exist, it loads
    '   their contents
    While i < 6
        tf = "Remote" + CStr(i) + ".txt"
        If Fso.FileExists(tf) Then
            Set TStream = Fso.OpenTextFile(tf)
            s = TStream.ReadLine
            
            'add remote to controler tree
            Set node1 = Init.Controlers.Nodes.Add("R", tvwChild, s, s)
            
            'allow for learning and binding of buttons
            Init.Learn.Visible = True
            Init.Bind.Visible = True
            
            'store new remote information
            StoredRemote(rcount).name = s
            StoredRemote(rcount).bcount = 0
            rcount = rcount + 1
            
            s = TStream.ReadLine 'reads blank line following remote name
            s = TStream.ReadLine 'gets first line entry
            
            'last line of text file is just ";" - stopping condition
            While s <> ";"
                
                'parses string s by delimitor ";", then stores each new
                '   sting in array saved
                saved = Split(s, ";")
                upper = UBound(saved) 'return number of elements in array

                'store new information in appropriate areas
                StoredRemote(i - 1).Button(StoredRemote(i - 1).bcount). _
                    func = saved(0)
                StoredRemote(i - 1).Button(StoredRemote(i - 1).bcount). _
                    code = saved(1)
                If saved(2) <> "" Then
                    'takes care of numbers saved as "_3", will be
                    '   displayeded as just "3"
                    saved2 = Replace(saved(2), "_", "")
                    
                    StoredRemote(i - 1). _
                        Button(StoredRemote(i - 1).bcount).act = saved(2)
                        
                    'Store new information in Controlers tree
                    Set node1 = Init.Controlers.Nodes. _
                            Add(StoredRemote(i - 1).name, tvwChild, _
                            saved(1), saved(0) + " : " + saved2)
                Else
                    StoredRemote(i - 1). _
                        Button(StoredRemote(i - 1).bcount).act = ""
                    
                    'Store new information in Controlers tree
                    Set node1 = Init.Controlers.Nodes. _
                        Add(StoredRemote(i - 1).name, tvwChild, _
                        saved(1), saved(0))
                End If
                'Updates button count
                StoredRemote(i - 1).bcount = StoredRemote(i - 1). _
                    bcount + 1
        
                s = TStream.ReadLine 'reads next entry line
            Wend
            TStream.Close
        End If
        i = i + 1
    Wend
    
    'Used for cycling windows - just an example, not fully functional
    Windows(0) = History.hwnd
    WindowsCount = 1
    WindowsPointer = 0
   
End Sub


'Called when user wants to clear the history window
Private Sub Clear_Click()

    Status.Panels(1).Picture = LoadPicture(GO_BMP)
    Status.Panels(2).Text = ""
    List1.Clear

End Sub


'Called when the RThreshold has been meet in the comm port. In this
'   case the RThreshold is set to 6, so when the comm port receives
'   6 bytes the OnComm event is triggered
Private Sub MSComm1_OnComm()

'handles comm port messages
    Dim cmd, action, display As String
    Dim temp As Node
    
    Dim i, RemoteNum, tempindex As Integer
    
    Select Case MSComm1.CommEvent
   ' Handle each event or error by placing code below each case statement

   ' Errors
      Case comEventBreak   ' A Break was received.
      Case comEventFrame   ' Framing Error
      Case comEventOverrun   ' Data Lost.
      Case comEventRxOver   ' Receive buffer overflow.
      Case comEventRxParity   ' Parity Error.
      Case comEventTxFull   ' Transmit buffer full.
      Case comEventDCB   ' Unexpected error retrieving DCB

   ' Events
      Case comEvCD   ' Change in the CD line.
      Case comEvCTS   ' Change in the CTS line.
      Case comEvDSR   ' Change in the DSR line.
      Case comEvRing   ' Change in the Ring Indicator.
      Case comEvReceive   ' Received RThreshold # of chars.
      
            'Sleep to give time to process a infrared signal before
            '   getting another
            Sleep 200
            
            'Retrieve data from input buffer of comm port
            buffer = MSComm1.Input
            arr = buffer
            
            'Ensure that comman is 12 characters long
            '   (hex only returns "0" not "00")
            cmd = ""
            display = ""
            While i < 6
                If Len(Hex(arr(i))) = 1 Then
                    cmd = cmd + "0" + Hex(arr(i))
                    display = display + "0" + Hex(arr(i)) + " "
                Else
                    cmd = cmd + Hex(arr(i))
                    display = display + Hex(arr(i)) + " "
                End If
                i = i + 1
            Wend
            
            'add headecimal string to top of history list
            List1.AddItem display, 0
            
            'Add "_" because numbers can not start a TreeView key entry
            cmd = "_" + cmd
                    
            If Wait.Visible = True Then
                
                Unload Wait
                action = FindKey(ByVal cmd)
                If action = "~" Then
                    'Call FindNode1
                    '   - returns the number of selected remote in tree
                    RemoteNum = FindNode1()

                    'Stores new info in remotes array
                    StoredRemote(RemoteNum). _
                        Button(StoredRemote(RemoteNum).bcount).code = cmd
                    StoredRemote(RemoteNum). _
                        Button(StoredRemote(RemoteNum).bcount).func = _
                        Init.Functions.SelectedItem.Text
                    StoredRemote(RemoteNum).bcount = _
                        StoredRemote(RemoteNum).bcount + 1
                    
                    'Add new button to controlers tree
                    Set temp = Init.Controlers.Nodes. _
                        Add(Init.Controlers.SelectedItem.Key, tvwChild, _
                        cmd, Init.Functions.SelectedItem.Text)
                    Init.Controlers.Nodes(2).Expanded = True
                        
                    'Show Bind button
                    If Init.Bind.Visible = False Then
                        Init.Bind.Visible = True
                    End If
                Else
                    'Attempting to program an already programmed button
                    Init.Status.Panels(1).Picture = LoadPicture(STOP_BMP)
                    Init.Status.Panels(2).Text = "That button is" + _
                        " already programmed"
                    If Audio.Value = True Then
'###################### UNCOMMENT FOR SPEECH ########################
'                       Voice.Speak ("That button is already programmed")
'####################################################################
                    End If
                End If
                
            ElseIf Init.Visible = False Then
        
                action = FindKey(ByVal cmd)
                If action = "~" Then
                    'Button is not programmed
                    Status.Panels(1).Picture = LoadPicture(STOP_BMP)
                    Status.Panels(2).Text = "Button not programmed"
                    If Audio.Value = True Then
'###################### UNCOMMENT FOR SPEECH ########################
'                       Voice.Speak ("That button is not programmed")
'####################################################################
                    End If
                Else
                    'Button is a valid one
                    Status.Panels(1).Picture = LoadPicture(GO_BMP)
                    Status.Panels(2).Text = ""
                    'Used to keep track of how many times a button was
                    '   pressed to simulate power keys
                    If cmd = Previous Then
                        If TimeOut = True Then
                            SameCount = 0
                        Else
                            SameCount = SameCount + 1
                            Timer1.Enabled = False
                        End If
                    Else
                        SameCount = 0
                    End If
                    'Call PerformAction to complete the given action
                    PerformAction (action)
                    Previous = cmd
                End If
                Timer1.Enabled = True
                TimeOut = False
            End If
                           
      Case comEvSend ' There are SThreshold number of characters in the
                     '   transmit buffer.
                     
      Case comEvEOF   ' An EOF charater was found in the input stream
   End Select

End Sub


'Called from File menu bar
Private Sub InitializeRemotes_Click()

    Status.Panels(1).Picture = LoadPicture(GO_BMP)
    Status.Panels(2).Text = ""
    Init.Show (1) ' call Init as Modal
    
End Sub


'Called from Help menu bar
Private Sub About_Click()

    frmAbout.Show (1)   'call About Form as modal
    
End Sub


'Called from Help menu bar
Private Sub Instructions_Click()

    Instruction.Show (1)  'call Instructions Form as modal
    
End Sub


'Called everytime the Timer fires
Private Sub Timer1_Timer()
    
    'Used to simulate power keys
    TimeOut = True
    Timer1.Enabled = False
    
End Sub

'Mouse is over Clear History button
Private Sub Clear_MouseMove(Button As Integer, Shift As Integer, _
    X As Single, Y As Single)
    
    Status.Panels(3).Text = "Clears history list"
    
End Sub

'Mouse is over History list
Private Sub List1_MouseMove(Button As Integer, Shift As Integer, _
    X As Single, Y As Single)
    
    Status.Panels(3).Text = "History of remote commands"
    
End Sub

'Mouse is over Error frame
Private Sub Error_MouseMove(Button As Integer, Shift As Integer, _
    X As Single, Y As Single)
    
    Status.Panels(3).Text = "Chocie response mechanism"
    
End Sub

'Mouse is over Audio option button
Private Sub Audio_MouseMove(Button As Integer, Shift As Integer, _
    X As Single, Y As Single)
    
    Status.Panels(3).Text = "Verbal error notification"
    
End Sub

'Mouse is over StatusBar option button
Private Sub StatusBar_MouseMove(Button As Integer, Shift As Integer, _
    X As Single, Y As Single)
    
    Status.Panels(3).Text = "Display error in StatusBar"
    
End Sub

'Mouse is over the form
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, _
    X As Single, Y As Single)
    
    Status.Panels(3).Text = ""
    
End Sub


'Called before the form is unloaded
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

    Dim i, j As Integer
    Dim tf As String
    Dim Fso
    Dim TStream
    
    Set Fso = CreateObject("Scripting.FileSystemObject")

    'Delete all the original text files
    i = 1
    While i < 6
        tf = "Remote" + CStr(i) + ".txt"
        If Fso.FileExists(tf) Then Fso.DeleteFile tf, True
        i = i + 1
    Wend
    
    'Writes the stored information out to new text files
    While rcount > 0
        i = rcount
        Init.Controlers.SelectedItem = Init.Controlers.SelectedItem.Root
        Init.Controlers.SelectedItem = Init.Controlers.SelectedItem.Child
        
        While i > 1
            Init.Controlers.SelectedItem = Init.Controlers.SelectedItem.Next
            i = i - 1
        Wend
        
        i = rcount
        tf = "Remote" + CStr(rcount) + ".txt"
        
        Set TStream = Fso.CreateTextFile(tf, ForAppending)
        
        'Writes the remote name to the file
        TStream.WriteLine Init.Controlers.SelectedItem.Text
        TStream.WriteLine ""
        
        'Writes each a line to text file containing the function, code
        '   and the action, with semicolons inbetween
        j = 0
        While j < Init.Controlers.SelectedItem.Children
            TStream.WriteLine StoredRemote(i - 1).Button(j).func + ";" + _
                StoredRemote(i - 1).Button(j).code + ";" + StoredRemote(i - 1).Button(j).act + ";"
            j = j + 1
        Wend
        'Single semicolon to mark end of file
        TStream.WriteLine ";"
        
        rcount = rcount - 1
    Wend
    
    'Sets CanClose variable to true so that the Init form may be allowed
    '   to close
    CanClose = True

End Sub


'Called when application is exited from
Private Sub Form_Unload(Cancel As Integer)
    If commopen = True Then
        MSComm1.PortOpen = False
    End If
    End
   
End Sub
