VERSION 5.00
Begin VB.Form EnterRemote 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Remote Name"
   ClientHeight    =   1740
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   3150
   LinkTopic       =   "Init"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1740
   ScaleWidth      =   3150
   ShowInTaskbar   =   0   'False
   Begin VB.TextBox RName 
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   600
      Width           =   2655
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   1680
      TabIndex        =   2
      Top             =   1080
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   1080
      Width           =   1215
   End
   Begin VB.Label Instructions 
      Alignment       =   2  'Center
      Caption         =   "Please enter name of remote"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   240
      Width           =   2655
   End
End
Attribute VB_Name = "EnterRemote"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'********************************************************************
'   EnterRemote.frm
'       -Form called when user wants to add a new remote.  Allows the
'           user to type in the Remote name to be stored.  Only stores
'           up to 5 remotes at any given time.
'
'   Created by: Zac M. Leider
'   Date: May 5th, 2003
'   Project: PC Remote Control (SNC Senior Capstone '03)
'
'********************************************************************

Option Explicit


' Called when EnterRemote Form is created
Private Sub Form_Load()

    OKButton.Default = True
    
End Sub


' Cancel button has been pressed
Private Sub CancelButton_Click()

    Unload Me

End Sub


' OK button has been pressed
Private Sub OKButton_Click()

    If Len(RName.Text) > 0 Then     'Makes sure text has been entered
        
        Dim node1 As Node
        Dim i As Integer
        Dim unique As Boolean
        
        'Checks to make sure the name entered is not already used
        unique = True
        i = 0
        While i < rcount
            If RName.Text = StoredRemote(i).name Then unique = False
            i = i + 1
        Wend
        
        If unique = True Then   'Name is unique
        
            'Store entered name as a new remote and add to the Controls tree
            Set node1 = Init.Controlers.Nodes.Add("R", tvwChild, _
                RName.Text, RName.Text)
            node1.Selected = True
            
            Init.Learn.Visible = True
            
            StoredRemote(rcount).name = RName.Text
            StoredRemote(rcount).bcount = 0
            rcount = rcount + 1
            
            Init.Status.Panels(1).Picture = LoadPicture(GO_BMP)
            Init.Status.Panels(2).Text = ""
            
            Unload Me
            
        Else    'Name is not unigue
        
            If History.Audio.Value = True Then
'###################### UNCOMMENT FOR SPEECH ########################
'                Voice.Speak ("That remote name is already used")
'####################################################################
            End If
            Init.Status.Panels(1).Picture = LoadPicture(STOP_BMP)
            Init.Status.Panels(2).Text = "That remote name is already used"
            
        End If
    End If
    
End Sub

